/*
 * Code and supporting documentation (c) Copyright 1990 1991 Tektronix, Inc.
 * 	All Rights Reserved
 * 
 * This file is a component of an X Window System client which uses the Xcms 
 * Color Management System.  TekColor is a trademark of Tektronix, Inc.  The
 * TekColor Editor is the subject of U.S. and foreign patents pending.  The
 * term "TekHVC" designates a particular color space that is the subject of
 * U.S. Patent No. 4,985,853 (equivalent foreign patents pending).
 * Permission is hereby granted to use, copy, modify, sell, and otherwise
 * distribute this software and its documentation for the X Window System
 * environment, for any purpose and without fee, provided that:
 * 
 * 1.	The code and documentation are only used to implement a 
 *      TekColor Editor in an X Window System environment; and
 * 2.	This copyright and permission notice is reproduced in all copies
 * 	of the code and in supporting documentation.
 * 
 * Permission is granted to modify this code as required to allow it to
 * be compiled on any host computer, provided that the functionality of
 * the TekColor Editor is not modified in any way.  A description of any 
 * modifications must be sent to Tektronix, Inc.  Contact 
 * Tektronix Inc., P.O. Box 1000, Mail Station 60-850, 
 * Network Displays Division Engineering, Wilsonville, OR 97070.
 * 
 * Tektronix makes no representation about the suitability of this software
 * for any purpose.  It is provided "as is" and with all faults.
 * 
 * TEKTRONIX DISCLAIMS ALL WARRANTIES APPLICABLE TO THIS SOFTWARE,
 * INCLUDING THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT SHALL TEKTRONIX BE LIABLE FOR ANY
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
 * RESULTING FROM LOSS OF USE, DATA, OR PROFITS, WHETHER IN AN ACTION OF
 * CONTRACT, NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR THE PERFORMANCE OF THIS SOFTWARE.
 *  
 *	NAME
 *		xticiSD.h -- String definitions and miscellaneous for xtici_mit
 *
 *	DESCRIPTION
 *		
 *
 *	HISTORY
 *
 *	HISTORY END
 *
 */

#ifndef LINT
#ifdef RCS_ID
static char *rcsid=  "$Header: xticiSD.h,v 1.1 91/08/22 11:22:26 adamsc Exp $";
#endif /* RCS_ID */
#endif /* LINT */

#ifndef _XTICISD_h
#define _XTICISD_h

#include <X11/Xcms.h>

#define XtNactivateCallback	"activateCallback"
#define XtNarmCallback	"armCallback"
#define XtNarrowDirection	"arrowDirection"
#define XtNbase		"base"
#define XtNbitsRgb	"bitsRgb"
#define XtNblinkRate	"blinkRate"
#define XtNblueMask	"blueMask"
#define XtNcmapSize	"cmapSize"
#define XtNcolumns	"columns"
#define XtNdisarmCallback	"disarmCallback"
#define XtNfacing	"facing"
#define XtNfloatList	"floatList"
#define XtNfocusCallback	"focusCallback"
#define XtNformat	"format"
#define XtNgreenMask	"greenMask"
#define XtNhvc		"hvc"
#define XtNincrement	"increment"
#define	XtNlabelList	"labelList"
#define XtNlosingFocusCallback	"losingFocusCallback"
#define XtNmaximum	"maximum"
#define XtNminimum	"minimum"
#define XtNmodifyVerifyCallback	"modifyVerifyCallback"
#define XtNpixelInc	"pixelInc"
#ifndef MIT
#define XtNprinter	"printer"
#endif /* MIT */
#define XtNredMask	"redMask"
#define XtNsingleSelectionCallback	"singleSelectionCallback"
#define XtNsliderExtent	"sliderExtent"
#define XtNvalueChangedCallback		"valueChangedCallback"
/* #define XtNvisual	"visual" */
#define XtNzoom		"zoom"

#define XtCActivateCallback	"ActivateCallback"
#define XtCArmCallback	"ArmCallback"
#define XtCArrowDirection	"ArrowDirection"
#define XtCBase		"Base"
#define XtCBitsRgb	"BitsRgb"
#define XtCBlinkRate	"BlinkRate"
#define XtCBlueMask	"BlueMask"
#define XtCCmapSize	"CmapSize"
#define XtCColumns	"Columns"
#define XtCDisarmCallback	"DisarmCallback"
#define XtCFacing	"Facing"
#define XtCFloatList	"FloatList"
#define XtCFocusCallback	"FocusCallback"
#define XtCFormat	"Format"
#define XtCGreenMask	"GreenMask"
#define XtCHvc		"Hvc"
#define XtCIncrement	"Increment"
#define	XtCLabelList	"LabelList"
#define XtCLosingFocusCallback	"LosingFocusCallback"
#define XtCMaximum	"Maximum"
#define XtCMinimum	"Minimum"
#define XtCModifyVerifyCallback	"ModifyVerifyCallback"
#define XtCPixelInc	"PixelInc"
#ifndef MIT
#define XtCPrinter	"Printer"
#endif /* MIT */
#define XtCRedMask	"RedMask"
#define XtCSliderExtent	"SliderExtent"
#define	XtCXtStringList	"XtStringList"
/* #define XtCVisual	"Visual" */
#define XtCZoom		"Zoom"

#define XtRFloatList	"FloatList"
#define	XtRLabelList	"LabelList"
#define XtRHvc		"Hvc"
#ifndef MIT
#define XtRPrinter	"Printer"
#endif /* MIT */
#define	XtRXtStringList	"XtStringList"

/* legal facing values */
#define XtNormalFacing		0
#define XtReverseFacing		1
#define XtSwizzledFacing	2
#define XtSwizzledReverseFacing	3
#define XtTopFacing		4

/*
 * The practical chroma limit for most devices is less than 100,
 * but it might be > 100 for some device - white point - hue combinations.
 * Using the theoretical maximum is not a good idea because that will squash
 * all leaves into a tiny portion of the graph, making it harder to use.
 * This is a tradeoff between practical and theoretical limits.
 */
#define LeafMaxChroma 120.0

/*
 * A series of callback reasons.
 */
#define	CR_NO_CALLBACK				0
#define CR_SINGLE_SELECT			1
#define CR_ACTIVATE				2
#define CR_DISARM				3
#define CR_INCREMENT				4
#define CR_DECREMENT				5
#define CR_ARM					6
#define CR_VALUE_CHANGED			7
#define CR_FOCUS				8
#define CR_LOSING_FOCUS				9
#define CR_DRAG					10
#define CR_MODIFYING_TEXT_VALUE			11

/*
 * A series of defines to tell what events interested in
 */
#define NO_EVENT				0x00
#define ARM_EVENT				0x1 << 0
#define ACTIVATE_EVENT				0x1 << 1
/*
 * A callback structure returned by Hvcleaf activate callback.
 */
typedef struct {
    int reason;
    XEvent *event;
    XcmsColor *hvc;
} HvcCallbackStruct;

/*
 * A callback structure returned by TriText activate callback.
 */
typedef struct {
    int reason;
    XEvent *event;
    int index;
    XcmsFloat value;
} TriCallbackStruct;

/*
 *  Callback structure for colorbar and colorscale
 */
typedef struct {
    int		reason;
    XEvent	*event;
    int		value;
} ScaleCallbackStruct;

/* Callback structure for text modifications */
typedef struct {
    int		reason;
    XEvent	*event;
    int		doit;
    String	text;
} TextCallbackStruct;

#define XtorientationUp		    0
#define XtorientationDown	    1
#define XtorientationLeft	    2
#define XtorientationRight	    3

#endif /* _XTICISD_h */
